VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Buffer As String

Public Function InsertDWORD(Data As Long)
Buffer = Buffer & MakeDWORD(Data)
End Function

Public Function InsertWORD(Data As Integer)
Buffer = Buffer & MakeWORD(Data)
End Function

Public Function InsertBYTE(Data As Integer)
Buffer = Buffer & Chr(Data)
End Function

Public Function InsertNTString(ByRef Data As String)
Buffer = Buffer & Data & vbNullChar
End Function

Public Function InsertNonNTString(Data As String)
Buffer = Buffer & Data
End Function

Public Function MakeDWORD(Value As Long) As String
    Dim Result As String * 4
    CopyMemory ByVal Result, Value, 4
    MakeDWORD = Result
End Function

Public Function MakeWORD(Value As Integer) As String
    Dim Result As String * 2
    CopyMemory ByVal Result, Value, 2
    MakeWORD = Result
End Function

Public Function Clear()
Buffer = ""
End Function

Public Function GetDWORD(Data As String) As Long
Dim lReturn As Long
Call CopyMemory(lReturn, ByVal Data, 4)
GetDWORD = lReturn
End Function

Public Function GetWORD(Data As String) As Long
Dim lReturn As Long
Call CopyMemory(lReturn, ByVal Data, 2)
GetWORD = lReturn
End Function
Public Function StrToHex(ByVal String1 As String) As String
Dim strTemp As String, strReturn As String, I As Long
For I = 1 To Len(String1)
    strTemp = Hex(Asc(Mid(String1, I, 1)))
If Len(strTemp) = 1 Then strTemp = "0" & strTemp
strReturn = strReturn & " " & strTemp
Next I
    StrToHex = strReturn
End Function

Public Function HexToStr(ByVal Hex1 As String) As String
On Error Resume Next
    Dim strTemp As String, strReturn As String, I As Long
    If Len(Hex1) Mod 2 <> 0 Then Exit Function
    For I = 1 To Len(Hex1) Step 2
    strReturn = strReturn & Chr(Val("&H" & Mid(Hex1, I, 2)))
    Next I
    HexToStr = strReturn
End Function

Public Function MakeByte(ByVal Data As Byte) As String
Dim Result As String * 1
    On Error Resume Next
    CopyMemory ByVal Result, Data, 1
    MakeByte = Result
    On Error GoTo 0
End Function
Public Function SendBNCS(ByRef PacketID As Byte)
If frmMain.sckBNCS.State <> sckConnected Then Exit Function
'Debug.Print "BNCS <- " & vbNewLine & DebugOutput(Chr(&HFF) & MakeByte(PacketID) & MakeWORD(Len(Buffer) + 4) & Buffer)
frmMain.sckBNCS.SendData Chr(&HFF) & Chr$(PacketID) & MakeWORD(Len(Buffer) + 4) & Buffer
Clear
End Function

Public Function SendBNLS(PacketID As Byte)
If frmMain.sckBNLS.State <> sckConnected Then Exit Function
'Debug.Print "BNLS <- " & vbNewLine & DebugOutput(MakeWORD(Len(Buffer) + 3) & MakeByte(PacketID) & Buffer)
frmMain.sckBNLS.SendData MakeWORD(Len(Buffer) + 3) & MakeByte(PacketID) & Buffer
Clear
End Function

Public Function DebugOutput(ByVal sIn As String) As String
     Dim x1 As Long, y1 As Long
     Dim iLen As Long, iPos As Long
     Dim sB As String, sT As String
     Dim sOut As String
     Dim Offset As Long, sOffset As String
      
     iLen = Len(sIn)
     If iLen = 0 Then Exit Function
     sOut = ""
     Offset = 0
     For x1 = 0 To ((iLen - 1) \ 16)
         sOffset = Right$("0000" & Hex(Offset), 4)
         sB = String(48, " ")
         sT = "................"
         For y1 = 1 To 16
             iPos = 16 * x1 + y1
             If iPos > iLen Then Exit For
             Mid(sB, 3 * (y1 - 1) + 1, 2) = Right("00" & Hex(Asc(Mid(sIn, iPos, 1))), 2) & " "
             Select Case Asc(Mid(sIn, iPos, 1))
             Case 0, 9, 10, 13
             Case Else
                 Mid(sT, y1, 1) = Mid(sIn, iPos, 1)
             End Select
         Next y1
         If Len(sOut) > 0 Then sOut = sOut & vbCrLf
         sOut = sOut & sOffset & ":  "
         sOut = sOut & sB & "  " & sT
         Offset = Offset + 16
     Next x1
     DebugOutput = sOut
 End Function
Public Function KillNull(ByVal Text As String) As String
    Dim I As Integer
    I = InStr(1, Text, Chr(0))
    If I = 0 Then
        KillNull = Text
        Exit Function
    End If
    KillNull = Left(Text, I - 1)
End Function


