VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsQueue"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Queue As Collection
Private Sub Class_Initialize()
    Set Queue = New Collection
End Sub
Public Function Time(ByVal ConstantQueue As Integer) As Integer
    If Queue.Count <> 0 Then
        If (Len(Queue.Item(1)) > 60) Then
            Time = 2000 + (Len(Queue.Item(1)) * 35)
        Else
            Time = 3000 + (Len(Queue.Item(1)) * 30)
        End If
    Else
        Time = 0
    End If
End Function
Public Sub Enqueue(Message As String)
    Dim I As Integer, Denied As Boolean
    
        For I = 1 To Queue.Count
            If LCase$(Queue.Item(I)) = LCase$(Message) Then Denied = True
        Next I
        
        If Not Denied Then Queue.Add Message
End Sub
Public Function Peek() As Variant
    Peek = Queue.Item(1)
End Function
Public Function Dequeue() As Variant
    If Queue.Count < 0 Then Exit Function
    Dequeue = Queue.Item(1)
    Queue.Remove 1
End Function
Public Sub ClearQueue()
    Set Queue = Nothing
    Set Queue = New Collection
End Sub
Public Function Count()
    Count = Queue.Count
End Function
