Attribute VB_Name = "modDatabase"
Option Explicit
Public Const ATTR_A As Long = 2
Public Const ATTR_B As Long = 4
Public Const ATTR_C As Long = 8
Public Const ATTR_D As Long = 16
Public Const ATTR_E As Long = 32
Public Const ATTR_F As Long = 64
Public Const ATTR_I As Long = 128
Public Const ATTR_J As Long = 256
Public Const ATTR_L As Long = 512
Public Const ATTR_M As Long = 1024
Public Const ATTR_N As Long = 2048
Public Const ATTR_O As Long = 4096
Public Const ATTR_R As Long = 8192
Public Const ATTR_S As Long = 16384
Public Const ATTR_X As Long = 32768
Public Const ATTR_Z As Long = 65536
Public Function AttributeToString(ByVal Attr As Long) As String
    Dim buf As String
    If (Attr And ATTR_A) = ATTR_A Then buf = buf & "A"
    If (Attr And ATTR_B) = ATTR_B Then buf = buf & "B"
    If (Attr And ATTR_C) = ATTR_C Then buf = buf & "C"
    If (Attr And ATTR_D) = ATTR_D Then buf = buf & "D"
    If (Attr And ATTR_E) = ATTR_E Then buf = buf & "E"
    If (Attr And ATTR_F) = ATTR_F Then buf = buf & "F"
    If (Attr And ATTR_I) = ATTR_I Then buf = buf & "I"
    If (Attr And ATTR_J) = ATTR_J Then buf = buf & "J"
    If (Attr And ATTR_L) = ATTR_L Then buf = buf & "L"
    If (Attr And ATTR_M) = ATTR_M Then buf = buf & "M"
    If (Attr And ATTR_N) = ATTR_N Then buf = buf & "N"
    If (Attr And ATTR_O) = ATTR_O Then buf = buf & "O"
    'If (Attr And ATTR_R) = ATTR_R Then buf = buf & "R"
    If (Attr And ATTR_S) = ATTR_S Then buf = buf & "S"
    If (Attr And ATTR_X) = ATTR_X Then buf = buf & "X"
    If (Attr And ATTR_Z) = ATTR_Z Then buf = buf & "Z"
    AttributeToString = buf
End Function
Public Function ParseAttribute(ByVal Attr As Long) As Long
    ParseAttribute = StringToAttribute(AttributeToString(Attr))
End Function
Public Function ParseAttributeString(ByVal Attr As String) As String
    ParseAttributeString = AttributeToString(StringToAttribute(Attr))
End Function
Public Function StringToAttribute(ByVal Attr As String) As Long
    Dim buf As Long
    Attr = UCase$(Attr)
    If (InStrB(Attr, "A") > 0) Then buf = buf Or ATTR_A
    If (InStrB(Attr, "B") > 0) Then buf = buf Or ATTR_B
    If (InStrB(Attr, "C") > 0) Then buf = buf Or ATTR_C
    If (InStrB(Attr, "D") > 0) Then buf = buf Or ATTR_D
    If (InStrB(Attr, "E") > 0) Then buf = buf Or ATTR_E
    If (InStrB(Attr, "F") > 0) Then buf = buf Or ATTR_F
    If (InStrB(Attr, "I") > 0) Then buf = buf Or ATTR_I
    If (InStrB(Attr, "J") > 0) Then buf = buf Or ATTR_J
    If (InStrB(Attr, "L") > 0) Then buf = buf Or ATTR_L
    If (InStrB(Attr, "M") > 0) Then buf = buf Or ATTR_M
    If (InStrB(Attr, "N") > 0) Then buf = buf Or ATTR_N
    If (InStrB(Attr, "O") > 0) Then buf = buf Or ATTR_O
    'If (InStrB(Attr, "R") > 0) Then buf = buf Or ATTR_R
    If (InStrB(Attr, "S") > 0) Then buf = buf Or ATTR_S
    If (InStrB(Attr, "X") > 0) Then buf = buf Or ATTR_X
    If (InStrB(Attr, "Z") > 0) Then buf = buf Or ATTR_Z
    StringToAttribute = buf
End Function

