VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsClanList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Clan() As New clsClan

Public Function Count() As Long
On Error Resume Next
    Count = UBound(Clan)
End Function

Public Function GetClan() As clsClan()
    GetClan = Clan
End Function

Public Function GetByIndex(Index As Integer) As clsClan
On Error GoTo hErr:
    Set GetByIndex = Clan(Index)
    Exit Function
hErr:
    Set GetByIndex = New clsClan
End Function

Public Function GetByName(Username As String) As clsClan

    Dim I As Integer
    I = Find(Username)
    If I > -1 Then
        Set GetByName = Clan(I)
        Exit Function
    End If
    Dim Temp As New clsClan
    Set GetByName = Temp

End Function
Public Sub SetUser(Index As Long, User As clsGrouping)
    Set Clan(Index) = User
End Sub

Private Function Same(Str1 As String, Str2 As String) As Boolean
    Same = LCase$(Str1) = LCase$(Str2)
End Function

Public Sub Clear()
    ReDim Clan(0)
End Sub

Public Function GetShamans() As String
Dim I As Long, Temp As clsClan

    For I = 0 To UBound(Clan)
        Set Temp = Clan(I)
            If Temp.ClanRank = 3 Then
                GetShamans = GetShamans & Temp.Username & ", "
            End If
    Next I
    
    GetShamans = Left(GetShamans, Len(GetShamans) - 2)

End Function
Public Function Add(User As String, Rank As Byte, status As Byte, Location As String) As Boolean
    
    If Find(User) > -1 Then Add = False: Exit Function
    
    Dim IU As New clsClan
    With IU
        .Username = User
        .ClanRank = Rank
        .status = status
        .Location = Location
    End With
    
    If LenB(Clan(0).Username) = 0 Then
        Set Clan(0) = IU
    Else
        ReDim Preserve Clan(UBound(Clan) + 1)
        Set Clan(UBound(Clan)) = IU
    End If

    Add = True
End Function
Public Function findPattern(ByVal User As String) As Long
    If LenB(User) = 0 Then findPattern = -2: Exit Function
    Dim I As Integer
    User = LCase$(User)
    For I = UBound(Clan) To 0 Step -1
        If User = LCase$(Clan(I).Username) Then
            findPattern = I
            Exit Function
        End If
    Next I
    findPattern = -1
End Function

Public Function Find(ByVal User As String) As Long
    If LenB(User) = 0 Then Find = -2: Exit Function
    Dim I As Integer
    User = LCase$(User)
    For I = UBound(Clan) To 0 Step -1
        If User = LCase$(Clan(I).Username) Then
            Find = I
            Exit Function
        End If
    Next I
    Find = -1
End Function

Public Function matchUser(ByVal Match As String, ByRef Result() As Long) As Boolean
    If LenB(Match) = 0 Then matchUser = False: Exit Function
    Dim I() As Long, X As Integer
    ReDim I(0): I(0) = -1
    For X = UBound(Clan) To 0 Step -1
        If Matches(Clan(X).Username, Match) Then
            If I(0) = -1 Then
                I(0) = X
            Else
                ReDim Preserve I(UBound(I) + 1)
                I(UBound(I)) = X
            End If
        End If
    Next X
    If I(0) <> -1 Then matchUser = True
    Result = I
End Function

Public Function Remove(ByVal User As String) As Boolean
    Dim I As Long, R As Integer
    User = LCase$(User)
    If UBound(Clan) = 0 Then
        If LCase$(Clan(0).Username) = User Then
            ReDim Clan(0)
            Remove = True
            Exit Function
        End If
    End If
    For I = 0 To UBound(Clan)
        If User = LCase$(Clan(I).Username) Then
            For R = I To UBound(Clan) - 1
                Set Clan(R) = Clan(R + 1)
            Next R
            ReDim Preserve Clan(UBound(Clan) - 1)
            Remove = True
            Exit Function
        End If
    Next I
    Exit Function
End Function
Private Sub Class_Initialize()
    ReDim Clan(0) As New clsClan
End Sub

Private Sub Class_Terminate()
    ReDim Clan(0)
End Sub



