Attribute VB_Name = "modBNLSPackets"
Option Explicit

Public Sub SendBNLS0x03(Data As String)

    With PBuffer
        .InsertNonNTString Data
        .SendBNLS &H3
    End With

End Sub

Public Sub SendBNLS0x02()

    With PBuffer
        .InsertNTString Username
        .InsertNTString Password
        .SendBNLS &H2
    End With

End Sub

Public Sub SendBNLS0x10()

    With PBuffer
        .InsertDWORD BNLSProductID
        .SendBNLS &H10
    End With
    
End Sub

Public Sub SendBNLS0x7D_0x01(WardenData As String)
                Dim Temp As New clsPBuffer
                Dim I As Long

                CurrentWarden = WardenData
                
                If StoredFirstWarden = False Then
                    FirstWarden = WardenData
                    StoredFirstWarden = True
                End If

                With Temp
                    .InsertBYTE &H1
                    .InsertDWORD WardenCookie
                    .InsertWORD Len(WardenData)
                    .InsertNonNTString WardenData
                    .SendBNLS &H7D
                End With
                
End Sub

Public Sub SendBNLS0x7D_0x00()
            
            With PBuffer
            
                .InsertBYTE &H0
                .InsertDWORD WardenCookie
                .InsertDWORD BNLSProductID
                .InsertWORD 4
                .InsertNonNTString Mid(CDKeyData(0), 17, 4)
                .InsertNTString ""
                .InsertWORD 0
                .InsertBYTE 0
                .SendBNLS &H7D
            
            End With
            
End Sub

Public Sub SendBNLS0x1A()

    With PBuffer
    .InsertDWORD BNLSProductID
    .InsertDWORD &H0
    .InsertDWORD GetTickCount
    .InsertDWORD FileTimeLOW
    .InsertDWORD FileTimeHIGH
    .InsertNTString MPQString
    .InsertNTString ValueString
    .SendBNLS &H1A
    End With

End Sub

Public Sub SendBNLS0x0C()

    With PBuffer
    
        .InsertDWORD GetTickCount
        If ExpansionClient Then
            .InsertBYTE &H2
        Else
            .InsertBYTE &H1
        End If
        
        .InsertDWORD &H1
        .InsertDWORD ServerCookie
        .InsertNTString CDKey1
        
        If ExpansionClient Then .InsertNTString CDKey2

        .SendBNLS &HC
        
    End With

End Sub

Public Sub SendBNLS0x0D()

    With PBuffer
    
    .InsertDWORD LogonType
    .SendBNLS &HD
    
    End With


End Sub

Public Sub SendBNLS0x04()

    With PBuffer
        .InsertNTString Username
        .InsertNTString Password
        .SendBNLS &H4
    End With

End Sub

Public Sub SendBNLS0x0B()

    If CreateAccount = False Then
    
        With PBuffer
        
            .InsertDWORD Len(Password)
            .InsertDWORD &H2
            .InsertNonNTString Password
            .InsertDWORD SessionCookie
            .InsertDWORD ServerCookie
            .SendBNLS &HB
        
        End With
    
    Else
     
        With PBuffer
                
            .InsertDWORD Len(Password)
            .InsertDWORD &H0
            .InsertNonNTString Password
            .SendBNLS &HB
            
        End With
    
    End If

End Sub
