Attribute VB_Name = "modTimers"
Public Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Public Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Public ReconnectTimer As Long
Public WardenTimer As Long
Public Shamans As Collection
Public OpenName As String
Public OpenChannel As Boolean
Public OpenTimer As Long
Public ClanPrivate As Long
Public DDPTmr As Long
Public DDPUser As String
Public DDPDesignated As Boolean
'Reconnect

Public Sub StartReconnectTimer(Tick As Long)
    StopReconnectTimer
    ReconnectTimer = SetTimer(0, 0, Tick, AddressOf ReconnectTimerElasped)
End Sub
Public Sub StopReconnectTimer()
    ReconnectTimer = KillTimer(0, ReconnectTimer)
    ReconnectTimer = 0
End Sub
Public Function ReconnectTimerElasped() As Long
    If Not BNCSConnected Then Call Connect
    If BNCSConnected Then StopReconnectTimer
End Function

'Warden

Public Sub StartWardenTimer(Tick As Long)
    StopReconnectTimer
    WardenTimer = SetTimer(0, 0, Tick, AddressOf WardenTimerElasped)
End Sub
Public Sub StopWardenTimer()
    WardenTimer = KillTimer(0, WardenTimer)
    WardenTimer = 0
End Sub
Public Function WardenTimerElasped() As Long
    Call WardenProcess
End Function
Public Sub WardenProcess()

    If LenB(CurrentWarden) <> 0 Then
        Call SendBNLS0x7D_0x00
        IgnoreWarden = True
    End If
    StopWardenTimer
End Sub

'Clan Private

Public Sub StartClanPrivateTimer(Tick As Long)
    StopClanPrivateTimer
    ClanPrivate = SetTimer(0, 0, Tick, AddressOf ClanPrivateElasped)
End Sub
Public Sub StopClanPrivateTimer()
    ClanPrivate = KillTimer(0, ClanPrivate)
    ClanPrivate = 0
End Sub
Public Function ClanPrivateElasped() As Long
    Call ClanProcess
End Function
Public Sub ClanProcess()
    If OpenChannel = True And RemoteChannel = True Then
        If (GetTickCount() - OpenTimer) >= 15000 Then
            AddQ "/clan private"
            StopClanPrivateTimer
            OpenChannel = False
        End If
    End If
End Sub

' DDP

Public Sub StartDDPTimer(Tick As Long)
    StopDDPTimer
    DDPTmr = SetTimer(0, 0, Tick, AddressOf DDPElasped)
    Set Shamans = New Collection
    DDPDesignated = False
End Sub
Public Sub StopDDPTimer()
    DDPTmr = KillTimer(0, DDPTmr)
    DDPTmr = 0
End Sub
Public Function DDPElasped() As Long
    Call DDP
End Function
Public Sub DDP()
Dim I As Integer, UsrIndex As clsClan, Count As Integer, strSplt() As String

    For I = 0 To Clan.Count
        Set UsrIndex = Clan.GetByIndex(I)
        
        If UsrIndex.ClanRank = &H3 And DDPDesignated = False And Users.Find(UsrIndex.Username) <> -1 Then
            Count = Count + 1
            Shamans.Add UsrIndex.Username
            SendRankChange UsrIndex.Username, &H2
            Exit Sub
        End If
    Next I
    
    If DDPDesignated = False And Count = 0 Then
        DDPDesignated = True
        AddQ "/designate " & DDPUser
        AddQ "/resign"
        Exit Sub
    End If
    
    If Shamans.Count = 0 Then StopDDPTimer: Exit Sub
    If DDPDesignated = True And Count = 0 Then
       For I = 1 To Shamans.Count
            SendRankChange Shamans.Item(I), &H3
            Shamans.Remove I
            Exit Sub
        Next I
    End If
    
End Sub

